﻿Imports System.IO
Imports OfficeOpenXml

Public Class Form1

	Private SourceData As New DataTable
	Private ResultsData As New DataTable
	Private Sub GenerateDataButton_Click(sender As Object, e As EventArgs) Handles GenerateDataButton.Click

		'Clear the SourceTable
		SourceData.Rows.Clear()


		'Declare variables
		Dim RecCount As Long = TotalRecordCountTextBox.Text
		Dim ProductCount As Integer = ProductCountTextBox.Text
		Dim CustomerCount As Integer = CustomerCountTextBox.Text

		Dim CurrentProdID As Integer
		Dim CurrentCustID As Integer
		Dim CurrentValue As Decimal

		'To distribute data, we will use random number generator

		For i As Long = 0 To RecCount - 1
			'Current CustomerID
			CurrentCustID = CustomerCount * Rnd() + 1

			'Current ProductID
			CurrentProdID = ProductCount * Rnd() + 1

			'Some Arbtrary assigned Order value
			CurrentValue = Math.Round(500 * Rnd(), 2)

			'Add row to SourceDataTable
			SourceData.Rows.Add(CurrentCustID, CurrentProdID, CurrentValue)
		Next

	End Sub

	Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
		SourceData = New DataTable

		'Add columns to SourceTable
		With SourceData
			.Columns.Add(New DataColumn("CustomerID", Type.GetType("System.Int32")))
			.Columns.Add(New DataColumn("ProductID", Type.GetType("System.Int32")))
			.Columns.Add(New DataColumn("OrderValue", Type.GetType("System.Decimal")))
		End With

		'Bind SourdeData to SourceDataGrid
		SourceDataGrid.DataSource = SourceData
		ResultsData = New DataTable


	End Sub

	Private Sub PivotTableButton_Click(sender As Object, e As EventArgs) Handles PivotTableButton.Click
		'Clear the results table
		ResultsData.Clear()
		'Declare timers
		Dim dt1 As DateTime = Now

		'Pivot the OrderValue over ProductID and group on CustomerID
		ResultsData = SourceData.Pivot("CustomerID", "ProductID", "OrderValue", PivotAction.Sum)

		'Show the time required to perform pivoting, in miliseconds
		MsgBox((Now - dt1).TotalMilliseconds)

		'Bind to datagridview
		ResultsDataGrid.DataSource = ResultsData

		'Show the correct tab:
		TabPage2.Focus()
	End Sub

	Private Sub SaveToExcelButton_Click(sender As Object, e As EventArgs) Handles SaveToExcelButton.Click
		'Declare SaveFile Dialog
		Dim sfd As New SaveFileDialog

		'Declare FileInfo object
		Dim FI As FileInfo

		'Declare Epplus Package
		Dim ep As New ExcelPackage

		'Workbook
		Dim wb As ExcelWorkbook = ep.Workbook

		'Declare sheet
		Dim sheet As ExcelWorksheet

		sfd.Filter = "Excel 2007 Files (*.xlsx)|*.xlsx"
		If sfd.ShowDialog = DialogResult.OK Then

			FI = New FileInfo(sfd.FileName)

			'SourceData into Excel Worksheet
			sheet = wb.Worksheets.Add("Source Data")
			sheet.Cells(1, 1).LoadFromDataTable(SourceData, True)

			'ResultsData into Excel Worksheet
			sheet = wb.Worksheets.Add("Results Data")
			sheet.Cells(1, 1).LoadFromDataTable(ResultsData, True)

			'Save ExcelPackage
			ep.SaveAs(FI)

			'Clear up
			sheet = Nothing
			wb = Nothing
			ep = Nothing
			ep.Dispose()
		End If
	End Sub
End Class
